# class Crystal::Macros::ExceptionHandler

- Crystal::Macros::ExceptionHandler
- Crystal::Macros::ASTNode

##
Overview

A `begin ... end` expression with `rescue`, `#else` and `#ensure` clauses.

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #body : ASTNode

  Returns this exception handler's main body.

- #else : ASTNode | Nop

  Returns this exception handler's `#else` clause body, if any.

- #ensure : ASTNode | Nop

  Returns this exception handler's `#ensure` clause body, if any.

- #rescues : ArrayLiteral(Rescue) | NilLiteral

  Returns this exception handler's `rescue` clauses, if any.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def body : ASTNode #

Returns this exception handler's main body.

def else : ASTNode | Nop #

Returns this exception handler's `#else` clause body, if any.

def ensure : ASTNode | Nop #

Returns this exception handler's `#ensure` clause body, if any.

def rescues : ArrayLiteral(Rescue) | NilLiteral #

Returns this exception handler's `rescue` clauses, if any.